import Enemy from "./Enemy";
import { MD } from "./MD";

const { ccclass, property } = cc._decorator;

@ccclass
export default class Boss extends cc.Component {

    constructor() {
        super()
        MD.Boss = this
    }

    onLoad() {
        this.enemyNodePool = new cc.NodePool(Enemy)
        for (let i = 0; i < 100; i++) {
            let node = cc.instantiate(this.enemy)
            this.enemyNodePool.put(node)
        }

        this.node.on('boss', this.boss, this)
    }

    onEnable() {
        this.schedule(this.createEnemy, 0.2, cc.macro.REPEAT_FOREVER, 0)
        // this.scheduleOnce(this.createEnemy, 0)
        this.hp = this.hpMax = 1
        this.hpTxt.string = this.hp.toString()
    }

    /**被打击 */
    hit() {
        this.hp -= 1
        this.hpTxt.string = this.hp.toString()
        this.hpBar.progress = this.hp / this.hpMax
        if (this.hp == 0) {
            this.rebirth()
        }
    }

    /**复活 */
    rebirth() {
        MD.main.recover()
        this.hp = this.hpMax = this.hpMax * 2
        this.hpTxt.string = this.hp.toString()
        this.hpBar.progress = 1
    }

    createEnemy() {
        let enemy = this.enemyNodePool.get()
        enemy.parent = this.enemys
    }

    boss(msg, target) {
        // console.error(target,'target')
        this.enemyNodePool.put(target)
    }

    @property(cc.Prefab)
    enemy: cc.Prefab = null

    @property(cc.Node)
    enemys: cc.Node = null

    @property(cc.ProgressBar)
    hpBar: cc.ProgressBar = null
    @property(cc.Label)
    hpTxt: cc.Label = null

    hp: number = 0
    hpMax: number = 0

    enemyNodePool: cc.NodePool = null

}
