import { MD } from "./MD";

const { ccclass, property } = cc._decorator;

@ccclass
export default class Enemy extends cc.Component {

    angle: number = 0

    speed: number = 200

    onEnable() {
        // console.error('show')
    }

    update(dt) {
        if (this.node.x > 350 - this.node.width / 2 || this.node.x < -350 + this.node.width / 2 || this.node.y > 630 - this.node.height / 2 || this.node.y < -630 + this.node.height / 2) {
            MD.main.hit()
            MD.Boss.node.emit('boss','',this.node)
            return
        }
        this.node.x += dt * this.speed * Math.sin(this.angle)
        this.node.y += dt * this.speed * Math.cos(this.angle)
    }

    onCollisionEnter(other,self)
    {
        MD.Boss.node.emit('boss','',this.node)
        // this.node.parent.emit('boss','',this.node)
    }

    reuse() {
        // console.error('使用')
        let r = Math.random() * 90
        this.angle = Math.random() * 360
        // this.angle = 90
        let x = r * Math.sin(this.angle)
        let y = r * Math.cos(this.angle)
        // this.node.setPosition()
        this.node.x = x
        this.node.y = y
    }

    unuse() {
        // console.error('回收')
    }
}
