import Boss from "./Boss";
import { MD } from "./MD";

const { ccclass, property } = cc._decorator;

@ccclass
export default class Gas extends cc.Component {

    targetNode: cc.Node = null

    speed: number = 500

    bossRing: number = -1

    onEnable() {
        this.selectNode()
    }


    selectNode() {
        let boss = MD.Boss.enemys
        let num = boss.childrenCount
        let random = Math.round(Math.random() * (num - 1))
        this.targetNode = boss.children[random]

        if (this.targetNode == undefined || this.targetNode == null || !this.targetNode.activeInHierarchy)
            return false
        else
            return true
    }

    update(dt) {
        if (this.targetNode == undefined || this.targetNode == null || !this.targetNode.activeInHierarchy) {
            if (this.selectNode()) {
                this.bossRing = -1
            } else {
                this.bossRing = Math.round(Math.random() * 8)
                this.targetNode = MD.Boss.node
            }
        }

        var delta = this.targetNode.getPosition().sub(this.node.getPosition())
        var distance = delta.mag()
        let pos = this.targetNode.getPosition()
        let angle = cc.misc.radiansToDegrees(Math.atan2(pos.x - this.node.x, pos.y - this.node.y))
        this.node.rotation = angle
        this.node.y += this.speed * dt * delta.y / distance
        this.node.x += this.speed * dt * delta.x / distance

    }

    onCollisionEnter(other, self) {
        if (other.node.group == 'boss') {
            if (other.tag == this.bossRing) {
                MD.Boss.hit()
                MD.main.node.emit('gas', '', self.node)
            }
        } else {
            MD.main.node.emit('gas', '', self.node)
        }
    }

    onCollisionStay(other, self) {
        if (other.node.group == 'boss') {
            if (other.tag == this.bossRing) {
                MD.Boss.hit()
                MD.main.node.emit('gas', '', self.node)
            }
        }
    }

    reuse() {

    }

    unuse() {
        this.targetNode = null
    }
}
