import Gas from "./Gas";
import { MD } from "./MD";

const { ccclass, property } = cc._decorator;

@ccclass
export default class main extends cc.Component {

    constructor() {
        super()
        MD.main = this
    }

    time: number = 3

    @property(cc.Vec2)
    startPos: cc.Vec2 = null

    @property(cc.Vec2)
    endPos: cc.Vec2 = null

    @property(cc.Node)
    moveNode: cc.Node = null

    speed: number = 500

    @property(cc.Prefab)
    gasPrefab: cc.Prefab = null

    @property(cc.Node)
    gasParent: cc.Node = null

    gasNodePool: cc.NodePool = null

    @property(cc.ProgressBar)
    hpBar: cc.ProgressBar = null
    hp: number = 100

    @property(cc.SpriteFrame)
    qipao23:cc.SpriteFrame = null
 


    onLoad() {
        cc.director.getCollisionManager().enabled = true
        // this.moveNode.on(cc.Node.EventType.TOUCH_MOVE, this.move, this)
        this.node.on(cc.Node.EventType.TOUCH_START, this.click, this)

        this.node.on('gas', this.gas, this)

        this.gasNodePool = new cc.NodePool(Gas)
        for (let i = 0; i < 100; i++) {
            let node = cc.instantiate(this.gasPrefab) 
            this.gasNodePool.put(node)
        }
    }

    hit() {
        this.hp -= 1
        this.hpBar.progress = this.hp / 100
        
    }


    recover() {
        this.hp = 100
        this.hpBar.progress = 1
    }

    click(event) {
        let gas = this.gasNodePool.get()
        // let pos = this.node.convertToNodeSpaceAR(event.getLocation()) //点击出现
        let pos = this.outPos

        gas.setPosition(pos)
        gas.parent = this.gasParent
    }

    /**获取随机外面位置 */
    get outPos() {
        let dir = Math.round(Math.random() * 3)
        let x, y
        switch (dir) {
            case 0://left
                x = -360
                y = Math.random() * 640 * (Math.random() > 0.5 ? -1 : 1)
                break
            case 1://right
                x = 360
                y = Math.random() * 640 * (Math.random() > 0.5 ? -1 : 1)
                break
            case 2://top
                x = Math.random() * 360 * (Math.random() > 0.5 ? -1 : 1)
                y = 640
                break
            case 3://down 
                x = Math.random() * 360 * (Math.random() > 0.5 ? -1 : 1)
                y = -640
                break
        }
        return new cc.Vec2(x, y)
    }

    move(event) {
        this.moveNode.x += event.getDeltaX()
        this.moveNode.y += event.getDeltaY()
    }

    gas(msg, target) {
        this.gasNodePool.put(target)
    }

    update(dt) {

        return
        // var delta = cc.pSub(this.moveNode.getPosition(), this.node.getPosition())
        var delta = this.moveNode.getPosition().sub(this.node.getPosition())

        // var distance = cc.pDistance(this.moveNode.getPosition(), this.node.getPosition())
        var distance = delta.mag()

        let pos = this.moveNode.getPosition()
        let angle = cc.misc.radiansToDegrees(Math.atan2(pos.x - this.node.x, pos.y - this.node.y))
        this.node.rotation = angle
        this.node.y += this.speed * dt * delta.y / distance
        this.node.x += this.speed * dt * delta.x / distance
    }

    onEnable() {
        // let movetoL = cc.moveTo(this.time,cc.v2(700,-207)) 
        // let movetoL = cc.moveTo(this.time,this.startPos) 
        // let delay = cc.delayTime(1)
        // // let movetoR = cc.moveTo(this.time,cc.v2(-700,-207))
        // let movetoR = cc.moveTo(this.time,this.endPos)
        // let seq = cc.sequence(movetoL,delay,movetoR,delay) 
        // this.node.runAction(cc.repeatForever(seq))
    }


}
