"use strict";
cc._RF.push(module, '09222ZNEd1CrJMEHftFc6iY', 'Boss');
// Script/Boss.ts

Object.defineProperty(exports, "__esModule", { value: true });
var Enemy_1 = require("./Enemy");
var MD_1 = require("./MD");
var _a = cc._decorator, ccclass = _a.ccclass, property = _a.property;
var Boss = /** @class */ (function (_super) {
    __extends(Boss, _super);
    function Boss() {
        var _this = _super.call(this) || this;
        _this.enemy = null;
        _this.enemys = null;
        _this.hpBar = null;
        _this.hpTxt = null;
        _this.hp = 0;
        _this.hpMax = 0;
        _this.enemyNodePool = null;
        MD_1.MD.Boss = _this;
        return _this;
    }
    Boss.prototype.onLoad = function () {
        this.enemyNodePool = new cc.NodePool(Enemy_1.default);
        for (var i = 0; i < 100; i++) {
            var node = cc.instantiate(this.enemy);
            this.enemyNodePool.put(node);
        }
        this.node.on('boss', this.boss, this);
    };
    Boss.prototype.onEnable = function () {
        this.schedule(this.createEnemy, 0.2, cc.macro.REPEAT_FOREVER, 0);
        // this.scheduleOnce(this.createEnemy, 0)
        this.hp = this.hpMax = 1;
        this.hpTxt.string = this.hp.toString();
    };
    /**被打击 */
    Boss.prototype.hit = function () {
        this.hp -= 1;
        this.hpTxt.string = this.hp.toString();
        this.hpBar.progress = this.hp / this.hpMax;
        if (this.hp == 0) {
            this.rebirth();
        }
    };
    /**复活 */
    Boss.prototype.rebirth = function () {
        MD_1.MD.main.recover();
        this.hp = this.hpMax = this.hpMax * 2;
        this.hpTxt.string = this.hp.toString();
        this.hpBar.progress = 1;
    };
    Boss.prototype.createEnemy = function () {
        var enemy = this.enemyNodePool.get();
        enemy.parent = this.enemys;
    };
    Boss.prototype.boss = function (msg, target) {
        // console.error(target,'target')
        this.enemyNodePool.put(target);
    };
    __decorate([
        property(cc.Prefab)
    ], Boss.prototype, "enemy", void 0);
    __decorate([
        property(cc.Node)
    ], Boss.prototype, "enemys", void 0);
    __decorate([
        property(cc.ProgressBar)
    ], Boss.prototype, "hpBar", void 0);
    __decorate([
        property(cc.Label)
    ], Boss.prototype, "hpTxt", void 0);
    Boss = __decorate([
        ccclass
    ], Boss);
    return Boss;
}(cc.Component));
exports.default = Boss;

cc._RF.pop();