(function() {"use strict";var __module = CC_EDITOR ? module : {exports:{}};var __filename = 'preview-scripts/assets/Script/Gas.js';var __require = CC_EDITOR ? function (request) {return cc.require(request, require);} : function (request) {return cc.require(request, __filename);};function __define (exports, require, module) {"use strict";
cc._RF.push(module, 'ed207HjuS1Nb78dS+ZP2lBZ', 'Gas', __filename);
// Script/Gas.ts

Object.defineProperty(exports, "__esModule", { value: true });
var MD_1 = require("./MD");
var _a = cc._decorator, ccclass = _a.ccclass, property = _a.property;
var Gas = /** @class */ (function (_super) {
    __extends(Gas, _super);
    function Gas() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.targetNode = null;
        _this.speed = 500;
        _this.bossRing = -1;
        return _this;
    }
    Gas.prototype.onEnable = function () {
        this.selectNode();
    };
    Gas.prototype.selectNode = function () {
        var boss = MD_1.MD.Boss.enemys;
        var num = boss.childrenCount;
        var random = Math.round(Math.random() * (num - 1));
        this.targetNode = boss.children[random];
        if (this.targetNode == undefined || this.targetNode == null || !this.targetNode.activeInHierarchy)
            return false;
        else
            return true;
    };
    Gas.prototype.update = function (dt) {
        if (this.targetNode == undefined || this.targetNode == null || !this.targetNode.activeInHierarchy) {
            if (this.selectNode()) {
                this.bossRing = -1;
            }
            else {
                this.bossRing = Math.round(Math.random() * 8);
                this.targetNode = MD_1.MD.Boss.node;
            }
        }
        var delta = this.targetNode.getPosition().sub(this.node.getPosition());
        var distance = delta.mag();
        var pos = this.targetNode.getPosition();
        var angle = cc.misc.radiansToDegrees(Math.atan2(pos.x - this.node.x, pos.y - this.node.y));
        this.node.rotation = angle;
        this.node.y += this.speed * dt * delta.y / distance;
        this.node.x += this.speed * dt * delta.x / distance;
    };
    Gas.prototype.onCollisionEnter = function (other, self) {
        if (other.node.group == 'boss') {
            if (other.tag == this.bossRing) {
                MD_1.MD.Boss.hit();
                MD_1.MD.main.node.emit('gas', '', self.node);
            }
        }
        else {
            MD_1.MD.main.node.emit('gas', '', self.node);
        }
    };
    Gas.prototype.onCollisionStay = function (other, self) {
        if (other.node.group == 'boss') {
            if (other.tag == this.bossRing) {
                MD_1.MD.Boss.hit();
                MD_1.MD.main.node.emit('gas', '', self.node);
            }
        }
    };
    Gas.prototype.reuse = function () {
    };
    Gas.prototype.unuse = function () {
        this.targetNode = null;
    };
    Gas = __decorate([
        ccclass
    ], Gas);
    return Gas;
}(cc.Component));
exports.default = Gas;

cc._RF.pop();
        }
        if (CC_EDITOR) {
            __define(__module.exports, __require, __module);
        }
        else {
            cc.registerModuleFunc(__filename, function () {
                __define(__module.exports, __require, __module);
            });
        }
        })();
        //# sourceMappingURL=Gas.js.map
        